Merge branch 'master', remote-tracking branch 'origin' into feature-diff-extra

This commit is contained in:
lhchavez 2020-08-18 05:49:04 -07:00
commit d48f93d653
7 changed files with 201 additions and 23 deletions

53
.github/workflows/backport.yml vendored Normal file
View File

@ -0,0 +1,53 @@
name: Backport to older releases
on:
push:
branches:
- master
jobs:
backport:
strategy:
fail-fast: false
matrix:
branch: [ 'release-0.28', 'release-0.27' ]
name: Backport change to branch ${{ matrix.branch }}
runs-on: ubuntu-20.04
steps:
- name: Check out code
uses: actions/checkout@v1
with:
fetch-depth: 0
- name: Create a cherry-pick PR
run: |
if ! git diff --quiet HEAD^ HEAD -- vendor/libgit2; then
echo '::warning::Skipping cherry-pick since it is a vendored libgit2 bump'
exit 0
fi
BRANCH_NAME="cherry-pick-${{ github.run_id }}-${{ matrix.branch }}"
# Setup usernames and authentication
git config --global user.name "${{ github.actor }}"
git config --global user.email "${{ github.actor }}@users.noreply.github.com"
cat <<- EOF > $HOME/.netrc
machine github.com
login ${{ github.actor }}
password ${{ secrets.GITHUB_TOKEN }}
machine api.github.com
login ${{ github.actor }}
password ${{ secrets.GITHUB_TOKEN }}
EOF
chmod 600 $HOME/.netrc
# Create the cherry-pick commit and create the PR for it.
git checkout "${{ matrix.branch }}"
git switch -c "${BRANCH_NAME}"
git cherry-pick -x "${{ github.sha }}"
git push --set-upstream origin "${BRANCH_NAME}"
GITHUB_TOKEN="${{ secrets.GITHUB_TOKEN }}" gh pr create \
--base "${{ matrix.branch }}" \
--title "$(git --no-pager show --format="%s" --no-patch HEAD)" \
--body "$(git --no-pager show --format="%b" --no-patch HEAD)"

View File

@ -46,10 +46,10 @@ jobs:
strategy: strategy:
fail-fast: false fail-fast: false
matrix: matrix:
go: [ '1.11', '1.12', '1.13' ] go: [ '1.11', '1.12', '1.13', '1.14' ]
name: Go ${{ matrix.go }} name: Go ${{ matrix.go }}
runs-on: ubuntu-18.04 runs-on: ubuntu-20.04
steps: steps:
- name: Set up Go - name: Set up Go
@ -71,13 +71,13 @@ jobs:
fail-fast: false fail-fast: false
name: Go (dynamic) name: Go (dynamic)
runs-on: ubuntu-18.04 runs-on: ubuntu-20.04
steps: steps:
- name: Set up Go - name: Set up Go
uses: actions/setup-go@v1 uses: actions/setup-go@v1
with: with:
go-version: '1.13' go-version: '1.14'
id: go id: go
- name: Check out code into the Go module directory - name: Check out code into the Go module directory
uses: actions/checkout@v1 uses: actions/checkout@v1
@ -87,3 +87,47 @@ jobs:
make build-libgit2-dynamic make build-libgit2-dynamic
- name: Test - name: Test
run: make test-dynamic run: make test-dynamic
build-system-dynamic:
strategy:
fail-fast: false
name: Go (system-wide, dynamic)
runs-on: ubuntu-20.04
steps:
- name: Set up Go
uses: actions/setup-go@v1
with:
go-version: '1.14'
id: go
- name: Check out code into the Go module directory
uses: actions/checkout@v1
- name: Build libgit2
run: |
git submodule update --init
sudo ./script/build-libgit2.sh --dynamic --system
- name: Test
run: make test
build-system-static:
strategy:
fail-fast: false
name: Go (system-wide, static)
runs-on: ubuntu-20.04
steps:
- name: Set up Go
uses: actions/setup-go@v1
with:
go-version: '1.14'
id: go
- name: Check out code into the Go module directory
uses: actions/checkout@v1
- name: Build libgit2
run: |
git submodule update --init
sudo ./script/build-libgit2.sh --static --system
- name: Test
run: go test --count=1 --tags "static,system_libgit2" ./...

28
.github/workflows/tag.yml vendored Normal file
View File

@ -0,0 +1,28 @@
name: Tag new releases
on:
push:
branches:
- master
- release-*
jobs:
tag-release:
name: Bump tag in ${{ github.ref }}
runs-on: ubuntu-20.04
steps:
- name: Check out code
uses: actions/checkout@v1
with:
fetch-depth: 0
- name: Bump version and push tag
id: bump-version
uses: anothrNick/github-tag-action@9aaabdb5e989894e95288328d8b17a6347217ae3
env:
GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }}
WITH_V: true
DEFAULT_BUMP: patch
TAG_CONTEXT: branch
RELEASE_BRANCHES: .*

View File

@ -31,7 +31,7 @@ The `master` branch follows the tip of libgit2 itself (with some lag) and as suc
### Which branch to send Pull requests to ### Which branch to send Pull requests to
If there's something version-specific that you'd want to contribute to, you can send them to the `release-${MAJOR}-${MINOR}` branches, which follow libgit2's releases. If there's something version-specific that you'd want to contribute to, you can send them to the `release-${MAJOR}.${MINOR}` branches, which follow libgit2's releases.
Installing Installing
---------- ----------

View File

@ -6,15 +6,21 @@
set -e set -e
if [ "$#" -eq "0" ]; then usage() {
echo "Usage: $0 <--dynamic|--static>">&2 echo "Usage: $0 <--dynamic|--static> [--system]">&2
exit 1 exit 1
}
if [ "$#" -eq "0" ]; then
usage
fi fi
ROOT="$(cd "$(dirname "$0")/.." && echo "${PWD}")" ROOT="$(cd "$(dirname "$0")/.." && echo "${PWD}")"
VENDORED_PATH="${ROOT}/vendor/libgit2" VENDORED_PATH="${ROOT}/vendor/libgit2"
BUILD_SYSTEM=OFF
case "$1" in while [ $# -gt 0 ]; do
case "$1" in
--static) --static)
BUILD_PATH="${ROOT}/static-build" BUILD_PATH="${ROOT}/static-build"
BUILD_SHARED_LIBS=OFF BUILD_SHARED_LIBS=OFF
@ -25,14 +31,29 @@ case "$1" in
BUILD_SHARED_LIBS=ON BUILD_SHARED_LIBS=ON
;; ;;
*) --system)
echo "Usage: $0 <--dynamic|--static>">&2 BUILD_SYSTEM=ON
exit 1
;; ;;
esac
mkdir -p "${BUILD_PATH}/build" "${BUILD_PATH}/install/lib" *)
usage
;;
esac
shift
done
if [ -z "${BUILD_SHARED_LIBS}" ]; then
usage
fi
if [ "${BUILD_SYSTEM}" = "ON" ]; then
BUILD_INSTALL_PREFIX="/usr"
else
BUILD_INSTALL_PREFIX="${BUILD_PATH}/install"
mkdir -p "${BUILD_PATH}/install/lib"
fi
mkdir -p "${BUILD_PATH}/build" &&
cd "${BUILD_PATH}/build" && cd "${BUILD_PATH}/build" &&
cmake -DTHREADSAFE=ON \ cmake -DTHREADSAFE=ON \
-DBUILD_CLAR=OFF \ -DBUILD_CLAR=OFF \
@ -40,7 +61,7 @@ cmake -DTHREADSAFE=ON \
-DREGEX_BACKEND=builtin \ -DREGEX_BACKEND=builtin \
-DCMAKE_C_FLAGS=-fPIC \ -DCMAKE_C_FLAGS=-fPIC \
-DCMAKE_BUILD_TYPE="RelWithDebInfo" \ -DCMAKE_BUILD_TYPE="RelWithDebInfo" \
-DCMAKE_INSTALL_PREFIX="${BUILD_PATH}/install" \ -DCMAKE_INSTALL_PREFIX="${BUILD_INSTALL_PREFIX}" \
-DCMAKE_INSTALL_LIBDIR="lib" \ -DCMAKE_INSTALL_LIBDIR="lib" \
"${VENDORED_PATH}" && "${VENDORED_PATH}" &&

View File

@ -6,6 +6,7 @@ package git
import "C" import "C"
import ( import (
"errors"
"runtime" "runtime"
"unsafe" "unsafe"
) )
@ -86,6 +87,9 @@ func (statusList *StatusList) ByIndex(index int) (StatusEntry, error) {
return StatusEntry{}, ErrInvalid return StatusEntry{}, ErrInvalid
} }
ptr := C.git_status_byindex(statusList.ptr, C.size_t(index)) ptr := C.git_status_byindex(statusList.ptr, C.size_t(index))
if ptr == nil {
return StatusEntry{}, errors.New("index out of Bounds")
}
entry := statusEntryFromC(ptr) entry := statusEntryFromC(ptr)
runtime.KeepAlive(statusList) runtime.KeepAlive(statusList)

View File

@ -61,3 +61,31 @@ func TestStatusList(t *testing.T) {
t.Fatal("Incorrect entry path: ", entry.IndexToWorkdir.NewFile.Path) t.Fatal("Incorrect entry path: ", entry.IndexToWorkdir.NewFile.Path)
} }
} }
func TestStatusNothing(t *testing.T) {
t.Parallel()
repo := createTestRepo(t)
defer cleanupTestRepo(t, repo)
seedTestRepo(t, repo)
opts := &StatusOptions{
Show: StatusShowIndexAndWorkdir,
Flags: StatusOptIncludeUntracked | StatusOptRenamesHeadToIndex | StatusOptSortCaseSensitively,
}
statusList, err := repo.StatusList(opts)
checkFatal(t, err)
entryCount, err := statusList.EntryCount()
checkFatal(t, err)
if entryCount != 0 {
t.Fatal("expected no statuses in empty repo")
}
_, err = statusList.ByIndex(0)
if err == nil {
t.Error("expected error getting status by index")
}
}